#ifndef CCONFIGDISPATCHER_H
#define CCONFIGDISPATCHER_H

#include <QObject>
#include <QtXml/QtXml>
#include <cseparatornode.h>

class CConfigDispatcher : public QObject
{
Q_OBJECT
private:
  QFile ConfigFile;
  QString ConfigFileName;
  QDomDocument ConfigDocument;
  QString GetAttributeFromNode(QDomNode Node, QString AttributeName);
  QList<CSeparatorNode*> Separators;
  void ParseDocument();
  void ProcessSeparatorsTag(QDomNode Node);
  void ProcessOptionsTag(QDomNode Node);
  void ProcessIncludeSeparator(QString FileName);
  void ProcessSeparatorNode(QDomNode Node); 
public:
  CConfigDispatcher(QObject *parent = 0);
  ~CConfigDispatcher();
  void Open(QString FileName);
  CSeparatorNode* GetSeparatorConfig(int i);
signals:
  void ErrorOpenConfigFile(QString & message);
  void ErrorReadingFile(QString &message, int &ErrorLine, int &ErrorColumn);
  void ErrorConfigFile(QString message);
public slots:
  void OnErrorOpenFile(QString & message);
  void OnErrorReadingFile(QString &message, int &ErrorLine, int &ErrorColumn);
  void OnErrorConfigFile(QString message);
};

#endif
