
#include "ccustomnode.h"

CCustomNode::CCustomNode(QObject *parent)
 : QObject(parent)
{
  Changed = false;
}


CCustomNode::~CCustomNode()
{
}

bool CCustomNode::ProcessByFile(QString FileName, bool CreateIfNotExists)
{
  ConfigFileName = FileName;
  ConfigFile.setFileName(FileName);
  bool FileExists = ConfigFile.exists();
  if (!CreateIfNotExists)
  {
    if (!FileExists)
     { 
        QString S = "Unable to open file " + FileName;
        emit ErrorOpenConfigFile(S);
        return false;
     } 
  }   
  if (ConfigFile.open(QFile::ReadOnly))
  {
    QString message;
    int line, column;
    if (Document.setContent(&ConfigFile, &message, &line, &column))
    {
      QDomElement Root = Document.documentElement();
      ConfigNode = Root;
      emit ProcessNode();
    } else {
             ConfigFile.close();
             QString S = "Unable to read file " + FileName + " " + message;  
             emit ErrorReadingFile(S, line, column);
           } 
  } else{ 
           ConfigFile.close();
           QString S = "Unable to open file " + FileName;  
           emit ErrorOpenConfigFile(S);
        } 
  ConfigFile.close();
  return true;
}

void CCustomNode::ProcessByNode(QDomNode Node)
{
   ConfigNode = Node;
   emit ProcessNode();
}

QDomNode CCustomNode::GetNode()
{
  return ConfigNode;
}


QString CCustomNode::GetAttributeValue(QDomNode Node, QString AttributeName)
{
  return Node.toElement().attribute(AttributeName, QString::null);
}

QString CCustomNode::GetAttributeValue(QString AttributeName)
{
  return GetAttributeValue(ConfigNode, AttributeName);
}


QString CCustomNode::GetAttributeValue(QDomNode Node, QString PrefixAttributeName, int index)
{
  QString StringIndex;
  StringIndex.setNum(index);
  QString AttrName = PrefixAttributeName + StringIndex;
  return GetAttributeValue(Node, AttrName);
}

void CCustomNode::SetAttributeValue(QString AttributeName, QString Value)
{
 ConfigNode.toElement().setAttribute(AttributeName, Value);
}

bool CCustomNode::isModified()
{
  return Changed;
}

bool CCustomNode::Save()
{
  QFile File(GetFileName());
  if (File.open(QFile::WriteOnly | QFile::Text))
  {
    QTextStream out(&File);
    ConfigNode.ownerDocument().save(out, 4);
    File.close();
    return true;
  } else return false;
}

QString CCustomNode::GetFileName()
{
  return ConfigFileName;
}

void CCustomNode::SetValue(QString Value)
{
  ConfigNode.setNodeValue(Value);
}



