#ifndef CCUSTOMNODE_H
#define CCUSTOMNODE_H

#include <QObject>
#include <QtXml/QtXml>

class CCustomNode : public QObject
{
Q_OBJECT
private:
  QFile ConfigFile;
  QDomDocument Document;
  QString ConfigFileName;
  QDomNode ConfigNode;
  bool Changed;
public:
  CCustomNode(QObject *parent = 0);
  ~CCustomNode();
  virtual void ProcessByNode(QDomNode Node);
  virtual bool ProcessByFile(QString FileName, bool CreateIfNotExists = false);
  QDomNode GetNode();
  QString GetAttributeValue(QString AttributeName);
  QString GetAttributeValue(QDomNode Node, QString AttributeName);
  QString GetAttributeValue(QDomNode Node, QString PrefixAttributeName, int index);
  void SetAttributeValue(QString AttributeName, QString Value); 
  void SetValue(QString Value); 
  bool isModified();
  bool Save();
  QString GetFileName();
signals:
  void ErrorOpenConfigFile(QString & message);
  void ErrorReadingFile(QString &message, int &line, int &column);
  void ErrorConfigFile(QString message);
  void FileCreated();
  void ProcessNode();
};

#endif
