
#include "cpropertynode.h"

CPropertyNode::CPropertyNode ( QObject* parent, int ValueCount ) 
:CCustomNode ( parent )
{
   connect(this, SIGNAL(ErrorConfigFile(QString)), this, SLOT(OnErrorConfigFile(QString)));
   connect(this, SIGNAL(ProcessNode()), this, SLOT(OnProcessNode()));
}

CPropertyNode::~CPropertyNode()
{
 qDeleteAll(Values.begin(), Values.end());
}

void CPropertyNode::OnErrorConfigFile(QString message)
{
}

void CPropertyNode::OnProcessNode()
{
  for(QDomNode Node = GetNode().firstChild(); !Node.isNull(); Node=Node.nextSibling())
  {
    if (Node.nodeName() == "VALUE")
    {
      ProcessValueNode(Node);
    }
  }
}

void CPropertyNode::ProcessValueNode(QDomNode Node)
{
   CValueNode* ValueNode = new CValueNode(this);
   ValueNode->ProcessByNode(Node);
   Values.append(ValueNode);
}

int CPropertyNode::getValueCount()
{
  if (GetNode().hasChildNodes())
   return GetNode().childNodes().count();
  else return 0;
}

QString CPropertyNode::GetCode()
{
  return GetAttributeValue("CODE");
}

CValueNode* CPropertyNode::operator [ ](int index)
{
   return Values[index];
}

CValueNode * CPropertyNode::GetValue(int index)
{
  return Values[index];
}
