#ifndef CSEPARATORNODE_H
#define CSEPARATORNODE_H

#include <ccustomnode.h>
#include <cpropertynode.h>
#include "radosdata.h"
#include <QtXml/QtXml>

class CSeparatorNode : public CCustomNode
{
Q_OBJECT
private:
  void ProcessPropertyNode(QDomNode Node);
  void ProcessPropertiesNode(QDomNode PropertiesNode);
  void ProcessSeparateSetupNode(QDomNode SepSetupNode);
  void ProcessSeparateSetupOblNode(QDomNode SepSetupOblNode);
  void ProcessRange(QDomNode Node, int ChannelIndex);
  void ProcessPrgNode(QDomNode PrgNode);
  void SaveSepSetup();
  QList<CPropertyNode*> Properties;
  TSeparateSetup FSeparateSetup;
  bool ConvertOK;
public:
  CSeparatorNode(QObject* parent=0);
  ~CSeparatorNode();
   QString GetIPAddress();
   void SetIPAddress(QString IP);
   QString GetName();
   void SetName(QString NAME);
   int GetPort();
   void SetPort(quint16 PORT); 
   CPropertyNode* CreateNewProperty(QString CODE, int ValueCount = 1);
   CPropertyNode* GetProperty(QString CODE);
   void DeleteProperty(QString CODE);
   TSeparateSetup GetSeparateSetup();
   void SetSeparateSetup(TSeparateSetup SepSetup);
   CPropertyNode* operator[](int i);
   CPropertyNode* operator[](QString CODE);
public slots:
  void OnErrorOpenConfigFile(QString & message);
  void OnErrorReadingFile(QString &message, int &line, int &column);
  void OnErrorConfigFile(QString message);
  void OnFileCreated();
  void OnProcessNode();
};

#endif
